﻿-- Author      : Apoco
-- Create Date : 4/23/2008 2:02:23 PM

local module = RBM:NewBossModule(RBM_GRUUL_DRAGON)
module:SetZones(RBM_GRUUL)

local player = UnitName("player")
function module:OnInitialize()
	self:RegisterToggles(RBM_GRUUL_DRAGON_GROW, true,
						 RBM_GRUUL_DRAGON_GRASP, true,
						 RBM_GRUUL_DRAGON_CAVEIN, true,
						 RBM_SILENCE, true,
						 RBM_RANGE_CHECK_FRAME, true)
	self:RegisterStartEvents("CHAT_MSG_MONSTER_YELL")
	RBM:DistanceFrameCreate(10)
	self.GraspLabel = self:CreateLabel(RBM_GRUUL_DRAGON_GRASP, RBM_COOLDOWN)
	self.SlamLabel = self:CreateLabel(RBM_GRUUL_DRAGON_NAME_SHORT, RBM_GRUUL_DRAGON_GROUNDSLAM)
	self.ShatterLabel = self:CreateLabel(RBM_GRUUL_DRAGON_NAME_SHORT, RBM_GRUUL_DRAGON_SHATTER)
	self.SilenceLabel = self:CreateLabel(RBM_SILENCE, RBM_COOLDOWN)
	self.GrowLabel = self:CreateLabel(RBM_GRUUL_DRAGON_NAME_SHORT, RBM_GRUUL_DRAGON_GROW)
	self.GraspSoon = function() self:Announce("Normal", RBM_GRUUL_DRAGON_GROUNDSLAM.." "..RBM_SOON) end
	self.SilenceSoon = function() self:Announce("High", RBM_SILENCE.." "..RBM_SOON) end
end

function module:CheckStart(event, msg)
	return msg == RBM_GRUUL_DRAGON_MSG_ENGAGE
end

function module:OnStart()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	if self:CheckToggle(RBM_RANGE_CHECK_FRAME) then
		RBM:DistanceFrameShow(10)
	end
	
	self.Grow = 0	
	if self:CheckToggle(RBM_GRUUL_DRAGON_GRASP) then
		self:ScheduleTimer(self.GraspSoon, 30)
		self:BossBar(self.GraspLabel, "Cooldown", 33, 33525)
	end
	if self:CheckToggle(RBM_SILENCE) then
		self:ScheduleTimer(self.SilenceSoon, 97)
		self:BossBar(self.SilenceLabel, "Cooldown", 102, 36297)
	end
	if self:CheckToggle(RBM_GRUUL_DRAGON_GROW) then
		self:BossBar(self.GrowLabel..": #"..self.Grow+1, "Cooldown", 30, 36300, true)
	end
end

function module:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, _, _, _, _, name, _, id, spell)
	if event == "SPELL_AURA_APPLIED" then
		if id == 36240 and name == player and self:CheckToggle(RBM_GRUUL_DRAGON_CAVEIN) then
			self:Alert("High", RBM_GRUUL_DRAGON_MSG_CAVEIN)
			self:FullPlayerAlert()
		end
		
	elseif event == "SPELL_CAST_START" then
		if id == 33654 and self:CheckToggle(RBM_GRUUL_DRAGON_GRASP) then
			self:Sync("Grasp", id)
		
		elseif id == 33525 and self:CheckToggle(RBM_GRUUL_DRAGON_SLAM) then
			self:Sync("Slam", id)
		end
		
	elseif event == "SPELL_CAST_SUCCESS" then
		if id == 36300 and self:CheckToggle(RBM_GRUUL_DRAGON_GROW) then
			self:Sync("Grow", id)
		
		elseif id == 36297 and self:CheckToggle(RBM_SILENCE) then
			self:Sync("Silence", id)
		end
	end
end

function module:OnSync(msg, id)
	if msg == "Grasp" then
		self:Announce("High", string.upper(RBM_GRUUL_DRAGON_SHATTER).."!")
		self:ScheduleTimer(self.GraspSoon, 56)
		self:BossBar(self.GraspLabel, "Cooldown", 62, id)
	
	elseif msg == "Slam" then
		self:Announce("High", RBM_GRUUL_DRAGON_MSG_SLAM)
		self:BossBar(self.ShatterLabel, "Cast", 10, id)
	
	elseif msg == "Grow" then
		self.Grow = self.Grow + 1
		self:Announce("High", RBM_GRUUL_DRAGON_GROW..":"..self.Grow)
		self:BossBar(self.GrowLabel..": #"..self.Grow+1, "Cooldown", 30, id, true)
		
	elseif msg == "Silence" then
		self:Announce("High", string.upper(RBM_SILENCE).."!")
		self:ScheduleTimer(self.SilenceSoon, 28)
		self:BossBar(self.SilenceLabel, 31, id)
	end
end
